import io.restassured.path.json.JsonPath;
import org.apache.commons.lang3.RandomStringUtils;
import org.junit.*;
import org.openqa.selenium.*;
import org.openqa.selenium.remote.DesiredCapabilities;
import org.openqa.selenium.remote.RemoteWebDriver;
import org.openqa.selenium.support.ui.ExpectedConditions;
import org.openqa.selenium.support.ui.WebDriverWait;
import static org.junit.Assert.*;
import io.restassured.RestAssured;
import io.restassured.response.Response;
import io.restassured.specification.RequestSpecification;
import org.json.simple.JSONObject;
import java.net.URL;


public class CreateAuthor {

    private static WebDriver driver = null;
    private static WebDriverWait wait = null;
    public String URL = Constants.URL;

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() throws Exception {
        //driver = new RemoteWebDriver(new URL("http://localhost:4444/wd/hub"), DesiredCapabilities.firefox());
        driver = new RemoteWebDriver(new URL("http://localhost:4444/wd/hub"), DesiredCapabilities.chrome());
        //driver.manage().timeouts().implicitlyWait(5, TimeUnit.SECONDS);
        wait = new WebDriverWait(driver, 10);
        String window = driver.getWindowHandle();
        ((JavascriptExecutor) driver).executeScript("alert('Test')");
        driver.switchTo().alert().accept();
        driver.switchTo().window(window);
        Utils.disableWarning();
    }


    @After
    public void tearDown() {
        driver.quit();
    }

    @Test
    public void createNewAuthor() throws Exception {

        String s = RandomStringUtils.randomAlphabetic(8);
        Utils.createAuthor(driver,wait, URL, s, Constants.firstname, Constants.lastname, Constants.affiliation, Constants.email+s+"@thinslices.com",Constants.password);


        try {
            wait.until(ExpectedConditions.presenceOfElementLocated(By.cssSelector("button[data-test='new-manuscript']")));
        } catch (NoSuchElementException e) {
            System.out.println(e.toString());
        }

        WebElement element = driver.findElement(By.xpath("//*[@id=\"root\"]/div/div/div[1]/div[1]/div[2]/div/span[2]"));
        String username = element.getText();

        assertEquals(Constants.firstname+s, username);

        RestAssured.baseURI = URL;

        //Get user token after login with new account

        RequestSpecification request = RestAssured.given().header("Content-Type", "application/json");

        JSONObject requestParams = new JSONObject();
        requestParams.put("username", Constants.email+s+"@thinslices.com");
        requestParams.put("password",  Constants.password);
        request.body(requestParams.toJSONString());
        Response response = request.post("api/users/authenticate");

        JsonPath jsonPathEvaluator = response.body().jsonPath();
        String token = jsonPathEvaluator.get("token");

        //Get user ID and confimationToken

        RequestSpecification requestUid = RestAssured.given().header("Authorization", "Bearer "+token);
        Response responseUid = requestUid.get("api/users/authenticate");
        JsonPath jsonPathEvaluatorUid = responseUid.body().jsonPath();

        String confirmationToken = jsonPathEvaluatorUid.get("confirmationToken");
        String uid = jsonPathEvaluatorUid.get("id");

        //Activate user

        driver.get(URL+"confirm-signup?userId="+uid+"&confirmationToken="+confirmationToken);

        try {
            wait.until(ExpectedConditions.presenceOfElementLocated(By.xpath(".//button[contains(text(),'"+"Go to Dashboard"+"')]")));
        } catch (NoSuchElementException e) {
            System.out.println(e.toString());
        }

        assertEquals("Your account has been successfully confirmed. Welcome to Hindawi!", driver.findElement(By.xpath("//*[@id=\"root\"]/div/div/div[2]/div/div")).getText());
    }
}
